/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.monitoring.statistics.portal;

import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.monitoring.MonitorNames;
import com.liferay.portal.monitoring.statistics.BaseDataSample;

/**
 * @author Rajesh Thiagarajan
 * @author Michael C. Han
 * @author Brian Wing Shun Chan
 */
public class PortalRequestDataSample extends BaseDataSample {

	public PortalRequestDataSample(
		long companyId, long groupId, String referer, String remoteAddr,
		String user, String requestURI, String requestURL, String userAgent) {

		_referer = referer;
		_remoteAddr = remoteAddr;
		_requestURL = requestURL;
		_userAgent = userAgent;

		setCompanyId(companyId);
		setGroupId(groupId);
		setName(requestURI);
		setNamespace(MonitorNames.PORTAL);
		setUser(user);
	}

	public String getReferer() {
		return _referer;
	}

	public String getRemoteAddr() {
		return _remoteAddr;
	}

	public String getRequestURL() {
		return _requestURL;
	}

	public int getStatusCode() {
		return _statusCode;
	}

	public String getUserAgent() {
		return _userAgent;
	}

	public void setStatusCode(int statusCode) {
		_statusCode = statusCode;
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(17);

		sb.append("{referer=");
		sb.append(_referer);
		sb.append(", ");
		sb.append("remoteAddr=");
		sb.append(_remoteAddr);
		sb.append(", ");
		sb.append("requestURL=");
		sb.append(_requestURL);
		sb.append(", ");
		sb.append("statusCode=");
		sb.append(_statusCode);
		sb.append(", ");
		sb.append("userAgent=");
		sb.append(_userAgent);
		sb.append(", ");
		sb.append(super.toString());
		sb.append("}");

		return sb.toString();
	}

	private final String _referer;
	private final String _remoteAddr;
	private final String _requestURL;
	private int _statusCode;
	private final String _userAgent;

}