/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.search.buffer;

import com.liferay.portal.kernel.util.AutoResetThreadLocal;

/**
 * @author Michael C. Han
 */
public class BufferOverflowThreadLocal {

	public static boolean isOverflowMode() {
		return _overflowMode.get();
	}

	public static void setOverflowMode(boolean overflowMode) {
		_overflowMode.set(overflowMode);
	}

	private static final ThreadLocal<Boolean> _overflowMode =
		new AutoResetThreadLocal<Boolean>(
			BufferOverflowThreadLocal.class + "._overflowMode", false);

}