/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.search.facet;

import com.liferay.portal.kernel.search.Document;
import com.liferay.portal.kernel.search.facet.Facet;
import com.liferay.portal.kernel.search.facet.FacetPostProcessor;
import com.liferay.portal.kernel.search.facet.collector.FacetCollector;

import java.util.Collection;

/**
 * @author Bryan Engler
 * @author André de Oliveira
 */
public class FacetPostProcessorImpl implements FacetPostProcessor {

	@Override
	public void exclude(Collection<Document> documents, Facet facet) {
		FacetCollector facetCollector = facet.getFacetCollector();

		if (facetCollector == null) {
			return;
		}

		FacetDiscounter facetDiscounter = new FacetDiscounter(facet);

		facetDiscounter.discount(documents);
	}

}