/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.security.auth;

import com.liferay.portal.kernel.security.pacl.DoPrivileged;
import com.liferay.portal.util.PropsValues;

/**
 * @author Peter Borkuti
 */
@DoPrivileged
public class InterruptedPortletRequestWhitelistImpl
	extends AbstractPortletRequestWhitelist {

	@Override
	public String[] getWhitelistActionsPropsValues() {
		return PropsValues.PORTLET_INTERRUPTED_REQUEST_WHITELIST_ACTIONS;
	}

	@Override
	public String[] getWhitelistPropsValues() {
		return PropsValues.PORTLET_INTERRUPTED_REQUEST_WHITELIST;
	}

}