/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.servlet.filters.util;

import com.liferay.portal.kernel.servlet.BrowserSniffer;
import com.liferay.portal.kernel.util.ArrayUtil;
import com.liferay.portal.kernel.util.ParamUtil;

import javax.servlet.http.HttpServletRequest;

/**
 * @author Ugurcan Cetin
 */
public class BrowserIdCacheFileNameContributor
	implements CacheFileNameContributor {

	@Override
	public String getParameterName() {
		return "browserId";
	}

	@Override
	public String getParameterValue(HttpServletRequest request) {
		String browserId = ParamUtil.getString(request, "browserId");

		if (ArrayUtil.contains(_BROWSER_IDS, browserId)) {
			return browserId;
		}

		return null;
	}

	private static final String[] _BROWSER_IDS = {
		BrowserSniffer.BROWSER_ID_FIREFOX, BrowserSniffer.BROWSER_ID_IE,
		BrowserSniffer.BROWSER_ID_OTHER
	};

}