/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.staging.web.internal.display.context;

import com.liferay.portal.kernel.language.LanguageUtil;
import com.liferay.portal.model.LayoutSetBranch;
import com.liferay.portal.model.LayoutSetBranchConstants;

import javax.servlet.jsp.PageContext;

/**
 * @author Mariano Alvaro Saiz
 */
public class LayoutSetBranchDisplayContext {

	public LayoutSetBranchDisplayContext(PageContext pageContext) {

		_pageContext = pageContext;
	}

	public String getLayoutSetBranchDisplayName(
		LayoutSetBranch layoutSetBranch) {

		return getLayoutSetBranchDisplayName(layoutSetBranch.getName());
	}

	public String getLayoutSetBranchDisplayName(String layoutSetBranchName) {
		if (_shouldTranslateLayoutSetBranchName(layoutSetBranchName)) {
			return LanguageUtil.get(_pageContext, layoutSetBranchName);
		}

		return layoutSetBranchName;
	}

	private boolean _shouldTranslateLayoutSetBranchName(
		LayoutSetBranch layoutSetBranch) {

		return _shouldTranslateLayoutSetBranchName(layoutSetBranch.getName());
	}

	private boolean _shouldTranslateLayoutSetBranchName(
		String layoutSetBranchName) {

		return LayoutSetBranchConstants.MASTER_BRANCH_NAME.equals(
			layoutSetBranchName);
	}

	private final PageContext _pageContext;

}