/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portlet.directory.asset;

import com.liferay.portal.model.Organization;
import com.liferay.portlet.asset.model.BaseAssetRenderer;

import java.util.Locale;

import javax.portlet.PortletRequest;
import javax.portlet.PortletResponse;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;

/**
 * @author Ricardo Couso
 */
public class OrganizationAssetRenderer extends BaseAssetRenderer {

	public OrganizationAssetRenderer(Organization organization) {
		_organization = organization;
	}

	@Override
	public String getClassName() {
		return Organization.class.getName();
	}

	@Override
	public long getClassPK() {
		return _organization.getPrimaryKey();
	}

	@Override
	public long getGroupId() {
		return _organization.getGroupId();
	}

	@Override
	public String getSummary(
		PortletRequest portletRequest, PortletResponse portletResponse) {

		return _organization.getComments();
	}

	@Override
	public String getTitle(Locale locale) {
		return _organization.getName();
	}

	@Override
	public long getUserId() {
		return _organization.getUserId();
	}

	@Override
	public String getUserName() {
		return _organization.getUserName();
	}

	@Override
	public String getUuid() {
		return _organization.getUuid();
	}

	@Override
	public String render(
		RenderRequest renderRequest, RenderResponse renderResponse,
		String template)
	throws Exception {

		return null;
	}

	private Organization _organization;

}