/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portlet.dynamicdatalists.action;

import com.liferay.portal.struts.FindAction;
import com.liferay.portal.util.PortletKeys;
import com.liferay.portlet.dynamicdatalists.model.DDLRecord;
import com.liferay.portlet.dynamicdatalists.service.DDLRecordLocalServiceUtil;

import javax.servlet.http.HttpServletRequest;

/**
 * @author Eudaldo Alonso
 */
public class FindRecordAction extends FindAction {

	@Override
	protected long getGroupId(long primaryKey) throws Exception {
		DDLRecord record = DDLRecordLocalServiceUtil.getRecord(primaryKey);

		return record.getGroupId();
	}

	@Override
	protected String getPrimaryKeyParameterName() {
		return "recordId";
	}

	@Override
	protected String getStrutsAction(
		HttpServletRequest request, String portletId) {

		return "/dynamic_data_list_display/view_record";
	}

	@Override
	protected String[] initPortletIds() {
		return new String[] {PortletKeys.DYNAMIC_DATA_LIST_DISPLAY};
	}

}