/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.kernel.exception;

import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

/**
 * @author Sergio González
 */
public class LocalizedException extends PortalException {

	public void addLocalizedException(Locale locale, Exception exception) {
		_localizedExceptionsMap.put(locale, exception);
	}

	public Map<Locale, Exception> getLocalizedExceptionsMap() {
		return _localizedExceptionsMap;
	}

	private Map<Locale, Exception> _localizedExceptionsMap =
		new HashMap<Locale, Exception>();

}