/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.kernel.util;

import java.util.Comparator;
import java.util.Locale;
import java.util.TimeZone;

/**
 * @author Brian Wing Shun Chan
 */
public class TimeZoneComparator implements Comparator<TimeZone> {

	public TimeZoneComparator() {
	}

	/**
	 * @deprecated As of 7.0.0, replaced by {@link #TimeZoneComparator()}
	 */
	public TimeZoneComparator(Locale locale) {
		_locale = locale;
	}

	@Override
	public int compare(TimeZone timeZone1, TimeZone timeZone2) {
		long currentTime = System.currentTimeMillis();

		Integer totalOffset1 = timeZone1.getOffset(currentTime);
		Integer totalOffset2 = timeZone2.getOffset(currentTime);

		int value = totalOffset1.compareTo(totalOffset2);

		if (value == 0) {
			String timeZoneId1 = timeZone1.getID();
			String timeZoneId2 = timeZone2.getID();

			value = timeZoneId1.compareTo(timeZoneId2);
		}

		return value;
	}

	private Locale _locale;

}