/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.portletfilerepository;

import com.liferay.portal.kernel.util.AutoResetThreadLocal;

/**
 * @author Kenneth Chang
 * @author Mate Thurzo
 */
public class PortletFileRepositoryThreadLocal {

	public static boolean isFileMaxSizeCheckEnabled() {
		return _fileMaxSizeCheckEnabled.get();
	}

	public static void setFileMaxSizeCheckEnabled(
		boolean fileMaxSizeCheckEnabled) {

		_fileMaxSizeCheckEnabled.set(fileMaxSizeCheckEnabled);
	}

	private static ThreadLocal<Boolean> _fileMaxSizeCheckEnabled =
		new AutoResetThreadLocal<Boolean>(
			PortletFileRepositoryThreadLocal.class +
				"._fileMaxSizeCheckEnabled", true);

}