/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.service;

import aQute.bnd.annotation.ProviderType;

import com.liferay.portal.kernel.bean.PortalBeanLocatorUtil;
import com.liferay.portal.kernel.util.ReferenceRegistry;

/**
 * Provides the local service utility for PortalInstances. This utility wraps
 * {@link com.liferay.portal.service.impl.PortalInstancesLocalServiceImpl} and is the
 * primary access point for service operations in application layer code running
 * on the local server. Methods of this service will not have security checks
 * based on the propagated JAAS credentials because this service can only be
 * accessed from within the same VM.
 *
 * @author Brian Wing Shun Chan
 * @see PortalInstancesLocalService
 * @see com.liferay.portal.service.base.PortalInstancesLocalServiceBaseImpl
 * @see com.liferay.portal.service.impl.PortalInstancesLocalServiceImpl
 * @generated
 */
@ProviderType
public class PortalInstancesLocalServiceUtil {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify this class directly. Add custom service methods to {@link com.liferay.portal.service.impl.PortalInstancesLocalServiceImpl} and rerun ServiceBuilder to regenerate this class.
	 */

	/**
	* Returns the Spring bean ID for this bean.
	*
	* @return the Spring bean ID for this bean
	*/
	public static java.lang.String getBeanIdentifier() {
		return getService().getBeanIdentifier();
	}

	/**
	* Sets the Spring bean ID for this bean.
	*
	* @param beanIdentifier the Spring bean ID for this bean
	*/
	public static void setBeanIdentifier(java.lang.String beanIdentifier) {
		getService().setBeanIdentifier(beanIdentifier);
	}

	public static void addCompanyId(long companyId) {
		getService().addCompanyId(companyId);
	}

	public static long getCompanyId(
		javax.servlet.http.HttpServletRequest request) {
		return getService().getCompanyId(request);
	}

	public static long[] getCompanyIds() {
		return getService().getCompanyIds();
	}

	public static long[] getCompanyIdsBySQL() throws java.sql.SQLException {
		return getService().getCompanyIdsBySQL();
	}

	public static long getDefaultCompanyId() {
		return getService().getDefaultCompanyId();
	}

	public static java.lang.String[] getWebIds() {
		return getService().getWebIds();
	}

	public static void initializePortalInstance(
		javax.servlet.ServletContext servletContext, java.lang.String webId) {
		getService().initializePortalInstance(servletContext, webId);
	}

	public static boolean isAutoLoginIgnoreHost(java.lang.String host) {
		return getService().isAutoLoginIgnoreHost(host);
	}

	public static boolean isAutoLoginIgnorePath(java.lang.String path) {
		return getService().isAutoLoginIgnorePath(path);
	}

	public static boolean isCompanyActive(long companyId) {
		return getService().isCompanyActive(companyId);
	}

	public static boolean isVirtualHostsIgnoreHost(java.lang.String host) {
		return getService().isVirtualHostsIgnoreHost(host);
	}

	public static boolean isVirtualHostsIgnorePath(java.lang.String path) {
		return getService().isVirtualHostsIgnorePath(path);
	}

	public static void reload(javax.servlet.ServletContext servletContext) {
		getService().reload(servletContext);
	}

	public static void removeCompany(long companyId) {
		getService().removeCompany(companyId);
	}

	public static void synchronizePortalInstances() {
		getService().synchronizePortalInstances();
	}

	public static PortalInstancesLocalService getService() {
		if (_service == null) {
			_service = (PortalInstancesLocalService)PortalBeanLocatorUtil.locate(PortalInstancesLocalService.class.getName());

			ReferenceRegistry.registerReference(PortalInstancesLocalServiceUtil.class,
				"_service");
		}

		return _service;
	}

	/**
	 * @deprecated As of 6.2.0
	 */
	public void setService(PortalInstancesLocalService service) {
	}

	private static PortalInstancesLocalService _service;
}