/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.service;

import aQute.bnd.annotation.ProviderType;

/**
 * Provides a wrapper for {@link PortalInstancesLocalService}.
 *
 * @author Brian Wing Shun Chan
 * @see PortalInstancesLocalService
 * @generated
 */
@ProviderType
public class PortalInstancesLocalServiceWrapper
	implements PortalInstancesLocalService,
		ServiceWrapper<PortalInstancesLocalService> {
	public PortalInstancesLocalServiceWrapper(
		PortalInstancesLocalService portalInstancesLocalService) {
		_portalInstancesLocalService = portalInstancesLocalService;
	}

	/**
	* Returns the Spring bean ID for this bean.
	*
	* @return the Spring bean ID for this bean
	*/
	@Override
	public java.lang.String getBeanIdentifier() {
		return _portalInstancesLocalService.getBeanIdentifier();
	}

	/**
	* Sets the Spring bean ID for this bean.
	*
	* @param beanIdentifier the Spring bean ID for this bean
	*/
	@Override
	public void setBeanIdentifier(java.lang.String beanIdentifier) {
		_portalInstancesLocalService.setBeanIdentifier(beanIdentifier);
	}

	@Override
	public void addCompanyId(long companyId) {
		_portalInstancesLocalService.addCompanyId(companyId);
	}

	@Override
	public long getCompanyId(javax.servlet.http.HttpServletRequest request) {
		return _portalInstancesLocalService.getCompanyId(request);
	}

	@Override
	public long[] getCompanyIds() {
		return _portalInstancesLocalService.getCompanyIds();
	}

	@Override
	public long[] getCompanyIdsBySQL() throws java.sql.SQLException {
		return _portalInstancesLocalService.getCompanyIdsBySQL();
	}

	@Override
	public long getDefaultCompanyId() {
		return _portalInstancesLocalService.getDefaultCompanyId();
	}

	@Override
	public java.lang.String[] getWebIds() {
		return _portalInstancesLocalService.getWebIds();
	}

	@Override
	public void initializePortalInstance(
		javax.servlet.ServletContext servletContext, java.lang.String webId) {
		_portalInstancesLocalService.initializePortalInstance(servletContext,
			webId);
	}

	@Override
	public boolean isAutoLoginIgnoreHost(java.lang.String host) {
		return _portalInstancesLocalService.isAutoLoginIgnoreHost(host);
	}

	@Override
	public boolean isAutoLoginIgnorePath(java.lang.String path) {
		return _portalInstancesLocalService.isAutoLoginIgnorePath(path);
	}

	@Override
	public boolean isCompanyActive(long companyId) {
		return _portalInstancesLocalService.isCompanyActive(companyId);
	}

	@Override
	public boolean isVirtualHostsIgnoreHost(java.lang.String host) {
		return _portalInstancesLocalService.isVirtualHostsIgnoreHost(host);
	}

	@Override
	public boolean isVirtualHostsIgnorePath(java.lang.String path) {
		return _portalInstancesLocalService.isVirtualHostsIgnorePath(path);
	}

	@Override
	public void reload(javax.servlet.ServletContext servletContext) {
		_portalInstancesLocalService.reload(servletContext);
	}

	@Override
	public void removeCompany(long companyId) {
		_portalInstancesLocalService.removeCompany(companyId);
	}

	@Override
	public void synchronizePortalInstances() {
		_portalInstancesLocalService.synchronizePortalInstances();
	}

	/**
	 * @deprecated As of 6.1.0, replaced by {@link #getWrappedService}
	 */
	public PortalInstancesLocalService getWrappedPortalInstancesLocalService() {
		return _portalInstancesLocalService;
	}

	/**
	 * @deprecated As of 6.1.0, replaced by {@link #setWrappedService}
	 */
	public void setWrappedPortalInstancesLocalService(
		PortalInstancesLocalService portalInstancesLocalService) {
		_portalInstancesLocalService = portalInstancesLocalService;
	}

	@Override
	public PortalInstancesLocalService getWrappedService() {
		return _portalInstancesLocalService;
	}

	@Override
	public void setWrappedService(
		PortalInstancesLocalService portalInstancesLocalService) {
		_portalInstancesLocalService = portalInstancesLocalService;
	}

	private PortalInstancesLocalService _portalInstancesLocalService;
}