<%--
/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/html/portlet/admin/init.jsp" %>

<%
List<ConvertProcess> convertProcesses = new ArrayList<ConvertProcess>();

for (String convertProcessClassName : PropsValues.CONVERT_PROCESSES) {
	ConvertProcess convertProcess = (ConvertProcess)InstancePool.get(convertProcessClassName);

	if (convertProcess.isEnabled()) {
		convertProcesses.add(convertProcess);
	}
}
%>

<c:choose>
	<c:when test="<%= convertProcesses.isEmpty() %>">
		<div class="alert alert-info">
			<liferay-ui:message key="no-data-migration-processes-are-available" />
		</div>
	</c:when>
	<c:otherwise>

		<%
		int i = 0;

		for (ConvertProcess convertProcess : convertProcesses) {
		%>

			<liferay-ui:panel-container extended="<%= true %>" id='<%= "convert" + i + "PanelContainer" %>' persistState="<%= true %>">
				<liferay-ui:panel collapsible="<%= true %>" extended="<%= true %>" id='<%= "convert" + i + "Panel" %>' persistState="<%= true %>" title="<%= convertProcess.getDescription() %>">
					<c:if test="<%= convertProcess.getParameterNames() != null %>">
						<aui:fieldset label='<%= Validator.isNotNull(convertProcess.getParameterDescription()) ? convertProcess.getParameterDescription() : "" %>'>

							<%
							for (String parameter : convertProcess.getParameterNames()) {
								if (parameter.contains(StringPool.EQUAL) && parameter.contains(StringPool.SEMICOLON)) {
									String[] parameterPair = StringUtil.split(parameter, CharPool.EQUAL);
									String[] parameterSelectEntries = StringUtil.split(parameterPair[1], CharPool.SEMICOLON);
							%>

								<aui:select label="<%= parameterPair[0] %>" name="<%= convertProcess.getClass().getName() + StringPool.PERIOD + parameterPair[0] %>">

									<%
									for (String parameterSelectEntry : parameterSelectEntries) {
									%>

										<aui:option label="<%= parameterSelectEntry %>" />

									<%
									}
									%>

								</aui:select>

							<%
								}
								else {
									String[] parameterPair = StringUtil.split(parameter, CharPool.EQUAL);

									String parameterName = null;
									String parameterType = null;

									if (parameterPair.length > 1) {
										parameterName = parameterPair[0];
										parameterType = parameterPair[1];
									}
									else {
										parameterName = parameter;
									}
							%>

									<aui:input cssClass="lfr-input-text-container" label="<%= parameterName %>" name="<%= convertProcess.getClass().getName() + StringPool.PERIOD + parameterName %>" type='<%= parameterType != null ? parameterType : "" %>' />

							<%
								}
							}
							%>

						</aui:fieldset>
					</c:if>

					<aui:button-row>

						<%
						String taglibConvertProcess = renderResponse.getNamespace() + "saveServer('convertProcess." + convertProcess.getClass().getName() + "');";
						%>

						<aui:button onClick="<%= taglibConvertProcess %>" value="execute" />
					</aui:button-row>
				</liferay-ui:panel>
			</liferay-ui:panel-container>

			<br />

		<%
			i++;
		}
		%>

	</c:otherwise>
</c:choose>